﻿unit Unit26;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls,
  Vcl.ExtCtrls, Data.DB, Data.Win.ADODB, ShellApi;

type
  TfReport = class(TForm)
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    Button1: TButton;
    dtpFrom: TDateTimePicker;
    Label1: TLabel;
    dtpTo: TDateTimePicker;
    Label2: TLabel;
    qKassa: TADOQuery;
    RadioGroup1: TRadioGroup;
    qFix: TADOQuery;
    qFixid: TIntegerField;
    qFixdate_end: TDateTimeField;
    qFixbrand: TWideStringField;
    qFixmodel: TWideStringField;
    qFixw_total: TFloatField;
    qFixsm_buyTotal: TFloatField;
    qFixsm_total: TFloatField;
    qFixuser: TWideStringField;
    qFixpercent: TIntegerField;
    qFixuser_id: TIntegerField;
    qKassaid: TAutoIncField;
    qKassadate: TDateField;
    qKassamove: TSmallintField;
    qKassamain_id: TIntegerField;
    qKassasumma: TFloatField;
    qKassabase: TWideStringField;
    qKassacomment: TWideMemoField;
    qKassauser_id: TIntegerField;
    qKassamove_str: TWideStringField;
    qClients: TADOQuery;
    qClientsid: TAutoIncField;
    qClientsdate: TDateTimeField;
    qClientsclient_name: TWideStringField;
    qClientsclient_phone: TWideStringField;
    qClientsmodel: TWideStringField;
    qClientsbrand: TWideStringField;
    qClientsdevtype: TWideStringField;
    procedure Button1Click(Sender: TObject);
    procedure frxKassaReportGetValue(const VarName: string; var Value: Variant);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fReport: TfReport;

implementation

{$R *.dfm}

uses Unit2;

procedure TfReport.Button1Click(Sender: TObject);
   var
      TS, Style: TStringList;
      strFile, rows, s_rows: string;
      userArray : Array of Double;
      i : integer;
      buy_total, m_total, w_total, sm_total, p_total, k_total : Double;
begin
   buy_total := 0;
   m_total   := 0;
   w_total   := 0;
   sm_total  := 0;
   p_total   := 0;
   k_total   := 0;
   TS := TStringList.Create;
   Style := TStringList.Create;
   if RadioGroup1.ItemIndex = 0 then begin
      TS.LoadFromFile('Report\fixReport.html');
      Style.LoadFromFile('Report\style.css');
      TS.Text := StringReplace(TS.Text, '{style}', Style.Text, [rfReplaceAll]);
      if qFix.Active then
         qFix.Close;
      qFix.Parameters[0].Value := FormatDateTime('yyyy-mm-dd', dtpFrom.Date)+' 00:00:00';
      qFix.Parameters[1].Value := FormatDateTime('yyyy-mm-dd', dtpTo.Date)+' 23:59:59';
      qFix.Open;
      while not qFix.Eof do begin
         // Собираем строки для таблицы
         rows := rows + '<tr>'+
                '<td>'+qFixid.AsString+'</td>'+
                '<td class="text-right">'+FormatDateTime('dd-mm-yyyy hh:mm', qFixdate_end.AsDateTime)+'</td>'+
                '<td class="text-left">' +qFixbrand.AsString+' '+qFixmodel.AsString+'</td>'+
                '<td class="text-right">'+CurrToStrF(qFixsm_buyTotal.AsFloat, ffNumber, 2)+' ₽</td>'+
                '<td class="text-right">'+CurrToStrF(qFixsm_total.AsFloat, ffNumber, 2)+' ₽</td>'+
                '<td class="text-right">'+CurrToStrF(qFixw_total.AsFloat, ffNumber, 2)+' ₽</td>'+
                '<td class="text-right">'+CurrToStrF((qFixw_total.AsFloat + qFixsm_total.AsFloat - qFixsm_buyTotal.AsFloat), ffNumber, 2)+' ₽</td>'+
                '</tr>';
         // Собираем итоги в переменные
         buy_total := buy_total + qFixsm_buyTotal.AsFloat;   // Цена закупки ТМЦ
         m_total   := m_total   + qFixsm_total.AsFloat;      // Наша цена ТМЦ (с накруткой сервиса)
         w_total   := w_total   + qFixw_total.AsFloat;       // Стоимость работ
         sm_total  := sm_total  + (qFixw_total.AsFloat + qFixsm_total.AsFloat - qFixsm_buyTotal.AsFloat);   // Наша цена + стоимость работ - цена закупки ТМЦ (затраты)
         qFix.Next;
      end;

      TS.Text := StringReplace(TS.Text, '{title}', 'Отчет по ремонтам за период с '+FormatDateTime('dd-mm-yyyy', dtpFrom.Date)+' по '+FormatDateTime('dd-mm-yyyy', dtpTo.Date), [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{buy_total}', CurrToStrF(buy_total, ffNumber, 2), [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{m_total}',   CurrToStrF(m_total,   ffNumber, 2), [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{w_total}',   CurrToStrF(w_total,   ffNumber, 2), [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{sm_total}',  CurrToStrF(sm_total,  ffNumber, 2), [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{kassa}',     CurrToStrF((m_total + w_total), ffNumber, 2), [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{rows}',      rows,                  [rfReplaceAll]);
      strFile := GetEnvironmentVariable('temp')+'\fixReport-'+FormatDateTime('-ddmmyy-hms', Now)+'.html';
      TS.SaveToFile(strFile);
      ShellExecute(Handle, 'open', PChar(strFile), nil, nil, SW_SHOWNORMAL);
   end;
   if RadioGroup1.ItemIndex = 1 then begin

      TS.LoadFromFile('Report\kassaReport.html');
      Style.LoadFromFile('Report\style.css');
      TS.Text := StringReplace(TS.Text, '{style}', Style.Text, [rfReplaceAll]);

      if qKassa.Active then
         qKassa.Close;
      qKassa.Parameters[0].Value := FormatDateTime('yyyy-mm-dd', dtpFrom.Date)+' 00:00:00';
      qKassa.Parameters[1].Value := FormatDateTime('yyyy-mm-dd', dtpTo.Date)+' 23:59:59';
      qKassa.Open;

      while not qKassa.Eof do begin
         // Собираем строки для таблицы
         rows := rows + '<tr>'+
                '<td class="text-center">'+qKassaid.AsString+'</td>'+
                '<td class="text-center">'+FormatDateTime('dd-mm-yyyy hh:mm', qKassadate.AsDateTime)+'</td>'+
                '<td class="text-left">'  +qKassabase.AsString+'</td>'+
                '<td class="text-left">'  +qKassamove_str.AsString+'</td>'+
                '<td class="text-center">'+CurrToStrF(qKassasumma.AsFloat, ffNumber, 2)+' ₽</td>'+
                '</tr>';
         // Собираем итоги в переменные
         if qKassamove.AsInteger = 1 then begin // В зависимости от типа операции
            k_total := k_total + qKassasumma.AsFloat; // Плюсуем сумму
         end
         else begin
            k_total := k_total - qKassasumma.AsFloat; // либо минусуем
         end;
         qKassa.Next;
      end;
      qKassa.Close;
      TS.Text := StringReplace(TS.Text, '{title}',   'Отчет по кассе за период с '+FormatDateTime('dd-mm-yyyy', dtpFrom.Date)+' по '+FormatDateTime('dd-mm-yyyy', dtpTo.Date), [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{k_total}', CurrToStrF(k_total, ffNumber, 2), [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{rows}',    rows,                             [rfReplaceAll]);

      strFile := GetEnvironmentVariable('temp')+'\kassaReport-'+FormatDateTime('-ddmmyy-hms', Now)+'.html';
      TS.SaveToFile(strFile);
      ShellExecute(Handle, 'open', PChar(strFile), nil, nil, SW_SHOWNORMAL);
   end;

   {****************************************************************************
   *********** Отчет по зарплате ***********************************************
   ****************************************************************************}
   if RadioGroup1.ItemIndex = 2 then begin
      TS.LoadFromFile('Report\salaryReport.html');
      Style.LoadFromFile('Report\style.css');
      TS.Text := StringReplace(TS.Text, '{style}', Style.Text, [rfReplaceAll]);

      if qFix.Active then
         qFix.Close;
      qFix.Parameters[0].Value := FormatDateTime('yyyy-mm-dd', dtpFrom.Date)+' 00:00:00';
      qFix.Parameters[1].Value := FormatDateTime('yyyy-mm-dd', dtpTo.Date)+' 23:59:59';
      qFix.Open;
      if DM.tUsers.Active then
         DM.tUsers.Close;
      DM.tUsers.Open;
      if DM.tUsers.RecordCount > 0 then begin
         SetLength(userArray, DM.tUsers.RecordCount);
      end
      else begin
         Exit;
      end;
      DM.tUsers.Close;

      while not qFix.Eof do begin
         // Собираем строки для таблицы
         rows := rows + '<tr>'+
                '<td>'+qFixid.AsString+'</td>'+
                '<td class="text-right">'+FormatDateTime('dd-mm-yyyy hh:mm', qFixdate_end.AsDateTime)+'</td>'+
                '<td class="text-left">' +qFixbrand.AsString+' '+qFixmodel.AsString+'</td>'+
                '<td class="text-right">'+qFixuser.AsString+'</td>'+
                '<td class="text-right">'+CurrToStrF(qFixw_total.AsFloat, ffNumber, 2)+' ₽</td>'+
                '<td class="text-right">'+CurrToStrF((qFixw_total.AsFloat * (qFixpercent.AsInteger / 100)), ffNumber, 2)+' ₽</td>'+
                '</tr>';
         // Собираем итоги в переменные
         w_total   := w_total   + qFixw_total.AsFloat;       // Стоимость работ
         userArray[qFixuser_id.AsInteger] := userArray[qFixuser_id.AsInteger] + qFixw_total.AsFloat * (qFixpercent.AsInteger / 100);
         p_total := p_total + qFixw_total.AsFloat * (qFixpercent.AsInteger / 100); // Игото на зарплату масетров
         qFix.Next;
      end;
      qFix.Close;
      if DM.tUsers.Active then
         DM.tUsers.Close;
      DM.tUsers.Open;
      s_rows := '';
      DM.tUsers.First;
      while not DM.tUsers.Eof do begin
         s_rows := s_rows + '<tr>'+
                '<td>'+DM.tUsersname.AsString+' ('+DM.tUserspercent.AsString+'%)</td>'+
                '<td class="text-right">'+CurrToStrF(userArray[DM.tUsersid.AsInteger], ffNumber, 2)+' ₽</td>'+
                '</tr>';
         DM.tUsers.Next;
      end;
      DM.tUsers.Close;

      TS.Text := StringReplace(TS.Text, '{title}', 'Отчет по зарплате за период с '+FormatDateTime('dd-mm-yyyy', dtpFrom.Date)+' по '+FormatDateTime('dd-mm-yyyy', dtpTo.Date), [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{p_total}',   CurrToStrF(p_total, ffNumber, 2), [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{w_total}',   CurrToStrF(w_total, ffNumber, 2), [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{rows}',      rows,                             [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{s_rows}',    s_rows,                           [rfReplaceAll]);

      strFile := GetEnvironmentVariable('temp')+'\salaryReport-'+FormatDateTime('-ddmmyy-hms', Now)+'.html';
      TS.SaveToFile(strFile);
      ShellExecute(Handle, 'open', PChar(strFile), nil, nil, SW_SHOWNORMAL);
   end;

   {****************************************************************************
   *********** Отчет по клиентам ***********************************************
   ****************************************************************************}
   if RadioGroup1.ItemIndex = 3 then begin
      TS.LoadFromFile('Report\clientsReport.html');
      Style.LoadFromFile('Report\style.css');
      TS.Text := StringReplace(TS.Text, '{style}', Style.Text, [rfReplaceAll]);

      if qClients.Active then
         qClients.Close;
      qClients.Parameters[0].Value := FormatDateTime('yyyy-mm-dd', dtpFrom.Date)+' 00:00:00';
      qClients.Parameters[1].Value := FormatDateTime('yyyy-mm-dd', dtpTo.Date)+' 23:59:59';
      qClients.Open;

      while not qClients.Eof do begin
         // Собираем строки для таблицы
         rows := rows + '<tr>'+
                '<td>'+qClientsid.AsString+'</td>'+
                '<td class="text-center">'+FormatDateTime('dd-mm-yyyy hh:mm', qClientsdate.AsDateTime)+'</td>'+
                '<td class="text-left">'+qClientsclient_name.AsString+' '+qClientsclient_phone.AsString+'</td>'+
                '<td class="text-left">'+qClientsdevtype.AsString+', '+qClientsbrand.AsString+', '+qClientsmodel.AsString+'</td>'+
                '</tr>';
         qClients.Next;
      end;
      qClients.Close;
      TS.Text := StringReplace(TS.Text, '{title}', 'Отчет по клиентам за период с '+FormatDateTime('dd-mm-yyyy', dtpFrom.Date)+' по '+FormatDateTime('dd-mm-yyyy', dtpTo.Date), [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{rows}', rows, [rfReplaceAll]);

      strFile := GetEnvironmentVariable('temp')+'\clientsReport-'+FormatDateTime('-ddmmyy-hms', Now)+'.html';
      TS.SaveToFile(strFile);
      ShellExecute(Handle, 'open', PChar(strFile), nil, nil, SW_SHOWNORMAL);
   end;
   TS.Free;
   Style.Free;
end;

procedure TfReport.FormCreate(Sender: TObject);
begin
   dtpFrom.Date := now();
   dtpTo.Date := now();
end;

procedure TfReport.frxKassaReportGetValue(const VarName: string;
  var Value: Variant);
begin
  if CompareText(VarName, 'dateFrom') = 0 then
     Value := FormatDateTime('yyyy-mm-dd', dtpFrom.Date);
  if CompareText(VarName, 'dateTo') = 0 then
     Value := FormatDateTime('yyyy-mm-dd', dtpTo.Date);
end;

end.
